// PointSprite.geom

// SetParameter GL_GEOMETRY_INPUT_TYPE_EXT=GL_POINTS
// SetParameter GL_GEOMETRY_OUTPUT_TYPE_EXT=GL_TRIANGLE_STRIP
// SetParameter GL_GEOMETRY_VERTICES_OUT_EXT=384

#version 150
//#extension GL_EXT_geometry_shader4 : enable
#extension GL_EXT_gpu_shader4 : enable

layout (points) in;
//layout (triangle_strip, max_vertices = 384) out;
//##LAYOUT_384##

uniform vec3 vertex[128];
uniform int indexList[128];
uniform int indexListSize;

uniform mat4 ModelViewProjectionMatrix;

in  vec4  positionIn4[];
in  float pointSizeIn[];

out vec3 position;

void main(void){
    vec4 nX = ModelViewProjectionMatrix * vec4(1, 0, 0, 0);
    vec4 nY = ModelViewProjectionMatrix * vec4(0, 1, 0, 0);
    vec4 nZ = ModelViewProjectionMatrix * vec4(0, 0, 1, 0);

    float psize = pointSizeIn[0];
    int flip = 0;
    if (psize < 0){
	flip = 1;
	psize *= -1;
    }

    nX *= psize;
    nY *= psize;
    nZ *= psize;

    int current = 0;
    int itemCount = 0;
    while (true){
	int index = indexList[current];
	if (index == -1){
	    if (itemCount != 0){
		EndPrimitive();
		itemCount = 0;
	    }
	}
	else {
	    gl_Position = positionIn4[0] + nX * vertex[index].x + nY * vertex[index].y + nZ * vertex[index].z;
	    EmitVertex();
	    if (flip == 1 && itemCount == 0) EmitVertex();
	    itemCount++;
	}
	    
	current ++;
	if (current >= indexListSize) break;
    }
}
