// PointSprite.vert

#version 120
// neccesary for attribute int
#extension GL_EXT_gpu_shader4 : enable 
#extension GL_ARB_explicit_attrib_location : enable

attribute float pointSize;
attribute int subIndex;

attribute vec3 tangent;
attribute vec3 binormal;

varying vec4  global_positionIn;
varying vec3  modelview_positionIn;
varying vec4  positionIn4;
varying float pointSizeIn;
varying int   subIndexIn;
varying vec3 normalIn;
varying vec3 tangentIn;
varying vec3 binormalIn;
varying vec4 gsFrontColorIn;

void main(void)
{
    vec3 position = vec3(gl_ModelViewMatrix * gl_Vertex);
    
    global_positionIn    = gl_Vertex;
    modelview_positionIn = position;
    positionIn4          = gl_ModelViewProjectionMatrix * gl_Vertex;
    
    gl_Position          = gl_ModelViewProjectionMatrix * gl_Vertex;
    gsFrontColorIn       = gl_Color;
    pointSizeIn          = pointSize;
    
    vec3 normal = gl_Normal;
    normalIn = normal;
    tangentIn = tangent;
    binormalIn = cross(normal, tangent);

    subIndexIn = subIndex;
}
