// simple.vert

#version 120
#extension GL_EXT_gpu_shader4 : enable
#extension GL_ARB_explicit_attrib_location : enable

uniform int lightNumber;
uniform float scatter;

attribute float pointSize;
attribute int subIndex;

varying vec3  modelview_positionIn;
varying vec4  positionIn4;
varying vec2  gsTexCoordIn;
varying float pointSizeIn;
varying int   subIndexIn;

varying vec3  viewVecIn;
varying vec3  normalIn;
varying vec3  binormalIn;
varying vec3  tangentIn;
varying vec4  gsFrontColorIn;


void main(void)
{
    vec3 position = vec3(gl_ModelViewMatrix * gl_Vertex);

    modelview_positionIn = position;
    positionIn4          = gl_ModelViewProjectionMatrix * gl_Vertex;
    
    gl_Position          = gl_ModelViewProjectionMatrix * gl_Vertex;
    gsFrontColorIn       = gl_Color;
    gsTexCoordIn         = gl_MultiTexCoord0.st;
    
    pointSizeIn          = pointSize;
    subIndexIn = subIndex;

    viewVecIn = -normalize(position);

    normalIn = vec3(0,0,1);
    binormalIn = vec3(0,1,0);
    tangentIn = vec3(1,0,0);
}

