// simple.vert

#version 130
#extension GL_EXT_gpu_shader4 : enable
#extension GL_ARB_explicit_attrib_location : enable

//uniform int lightNumber;
//uniform float scatter;

in  float pointSize;
in  int subIndex;

in  vec3 tangent;
in  vec3 binormal;

out vec4  global_positionIn;
out vec3  modelview_positionIn;
out vec4  positionIn4;
out vec2  gsTexCoordIn;
out float pointSizeIn;
out int   subIndexIn;

out vec3  viewVecIn;
out vec3  normalIn;
out vec3  binormalIn;
out vec3  tangentIn;
out vec4  gsFrontColorIn;

void main(void)
{
    vec3 position = vec3(gl_ModelViewMatrix * gl_Vertex);

    global_positionIn    = gl_Vertex;
    modelview_positionIn = position;
    positionIn4          = gl_ModelViewProjectionMatrix * gl_Vertex;
    
    gl_Position          = gl_ModelViewProjectionMatrix * gl_Vertex;
    gsFrontColorIn       = gl_Color;
    gsTexCoordIn         = gl_MultiTexCoord0.st;

    pointSizeIn          = pointSize;
    subIndexIn = subIndex;

    viewVecIn = -normalize(position);

    vec3 normal = gl_Normal;
    normalIn = normal;
    tangentIn = tangent;
    binormalIn = cross(normal, tangent);
}

