
// Template with no anchor.

#declare tgt0 = <1, 0, 0>;
#declare top0 = <0, 0, 1>;
#declare rgt0 = <0, -1, 0>;

#declare Yaw=Camera_Rotation_z * pi / 180;
#declare cosYaw=cos(Yaw);
#declare sinYaw=sin(Yaw);

#declare tgt1 = <cosYaw * tgt0.x - sinYaw * rgt0.x, 
                 cosYaw * tgt0.y - sinYaw * rgt0.y,
                 cosYaw * tgt0.z - sinYaw * rgt0.z>;
#declare rgt1 = <cosYaw * rgt0.x + sinYaw * tgt0.x, 
                 cosYaw * rgt0.y + sinYaw * tgt0.y,
                 cosYaw * rgt0.z + sinYaw * tgt0.z>;
#declare top1 = <top0.x, top0.y, top0.z>;

#declare Pitch=Camera_Rotation_y * pi / 180;
#declare cosPitch=cos(Pitch);
#declare sinPitch=sin(Pitch);

#declare tgt2 = <cosPitch * tgt1.x - sinPitch * top1.x, 
                 cosPitch * tgt1.y - sinPitch * top1.y,
                 cosPitch * tgt1.z - sinPitch * top1.z>;
#declare top2 = <cosPitch * top1.x + sinPitch * tgt1.x, 
                 cosPitch * top1.y + sinPitch * tgt1.y,
                 cosPitch * top1.z + sinPitch * tgt1.z>;
#declare rgt2 = <rgt1.x, rgt1.y, rgt1.z>;

#declare Roll=Camera_Rotation_x * pi / 180;
#declare cosRoll=cos(Roll);                  
#declare sinRoll=sin(Roll);

#declare top3 = <cosRoll * top2.x + sinRoll * rgt2.x, 
                 cosRoll * top2.y + sinRoll * rgt2.y,
                 cosRoll * top2.z + sinRoll * rgt2.z>;
#declare rgt3 = <cosRoll * rgt2.x - sinRoll * top2.x, 
                 cosRoll * rgt2.y - sinRoll * top2.y,
                 cosRoll * rgt2.z - sinRoll * top2.z>;
#declare tgt3 = tgt2;

// Stereogram

#declare Camera_Translate_x = Camera_Translate_x + rgt3.x * Stereogram_DistanceOfEye * StereoFactor / 2;
#declare Camera_Translate_y = Camera_Translate_y + rgt3.y * Stereogram_DistanceOfEye * StereoFactor / 2;
#declare Camera_Translate_z = Camera_Translate_z + rgt3.z * Stereogram_DistanceOfEye * StereoFactor / 2;

#declare ToeInRadian = StereoToeIn * pi / 180 * StereoFactor;
#declare cosToeIn=cos(ToeInRadian);
#declare sinToeIn=sin(ToeInRadian);

#declare top4 = top3;
#declare rgt4 = <cosToeIn * rgt3.x + sinToeIn * tgt3.x,
	         cosToeIn * rgt3.y + sinToeIn * tgt3.y,
	         cosToeIn * rgt3.z + sinToeIn * tgt3.z>;
#declare tgt4 = <cosToeIn * tgt3.x - sinToeIn * rgt3.x,
                 cosToeIn * tgt3.y - sinToeIn * rgt3.y,
                 cosToeIn * tgt3.z - sinToeIn * rgt3.z>;

// DomeOffset

#declare FisheyeOffsetRadian = FisheyeOffset * pi / 180;
#declare cosFisheyeOffset=cos(FisheyeOffsetRadian);
#declare sinFisheyeOffset=sin(FisheyeOffsetRadian);

#declare top5 = <cosFisheyeOffset * top4.x + sinFisheyeOffset * tgt4.x,
	         cosFisheyeOffset * top4.y + sinFisheyeOffset * tgt4.y,	
	         cosFisheyeOffset * top4.z + sinFisheyeOffset * tgt4.z>;
#declare rgt5 = rgt4;
#declare tgt5 = <cosFisheyeOffset * tgt4.x - sinFisheyeOffset * top4.x,
	         cosFisheyeOffset * tgt4.y - sinFisheyeOffset * top4.y,	
	         cosFisheyeOffset * tgt4.z - sinFisheyeOffset * top4.z>;

#declare Anchor_Translate_x = Camera_Translate_x + tgt5.x;
#declare Anchor_Translate_y = Camera_Translate_y + tgt5.y;
#declare Anchor_Translate_z = Camera_Translate_z + tgt5.z;

#declare Camera=camera {
	CAMERATYPE
	location<Camera_Translate_x,Camera_Translate_y,Camera_Translate_z>
	look_at<Anchor_Translate_x,Anchor_Translate_y,Anchor_Translate_z>
   	sky top5
	angle CameraAngle
	right -x*image_width/image_height
}
